/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.openjena.riot.pipeline.inf;

import org.openjena.atlas.lib.Sink ;

import com.hp.hpl.jena.graph.Triple ;
import com.hp.hpl.jena.rdf.model.Model ;
import com.hp.hpl.jena.sparql.core.Quad ;

public class InfFactory
{
    public static Sink<Triple> infTriples(Sink<Triple> sink, Model vocab)
    {
        InferenceSetupRDFS setup =  new InferenceSetupRDFS(vocab) ;
        return new InferenceProcessorTriples(sink, setup) ; 
    }
    
    public static Sink<Quad> infQuads(Sink<Quad> sink, Model vocab)
    {
        InferenceSetupRDFS setup =  new InferenceSetupRDFS(vocab) ;
        return new InferenceProcessorQuads(sink, setup) ; 
    }

    public static Sink<Triple> infTriples(Sink<Triple> sink, InferenceSetupRDFS setup)
    {
        return new InferenceProcessorTriples(sink, setup) ; 
    }
    
    public static Sink<Quad> infQuads(Sink<Quad> sink, InferenceSetupRDFS setup)
    {
        return new InferenceProcessorQuads(sink, setup) ; 
    }
}
